CREATE TABLE IF NOT EXISTS `chessgames` (
  `gameID` smallint(6) NOT NULL auto_increment,
  `whitePlayer` mediumint(9) NOT NULL,
  `whiteName` varchar(80) collate latin1_german1_ci NOT NULL,
  `blackPlayer` mediumint(9) NOT NULL,
  `blackName` varchar(80) collate latin1_german1_ci NOT NULL,
  `gameMessage` enum('playerInvited','inviteDeclined','draw','playerResigned','checkMate') collate latin1_german1_ci default NULL,
  `messageFrom` enum('black','white') collate latin1_german1_ci default NULL,
  `dateCreated` datetime NOT NULL,
  `lastMove` datetime NOT NULL,
  `pieces` text collate latin1_german1_ci NOT NULL,
  `bet` smallint(6) NOT NULL default '0' COMMENT '<10: Gems; >10: Gold',
  PRIMARY KEY  (`gameID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci AUTO_INCREMENT=7 ;


CREATE TABLE IF NOT EXISTS `chesshistory` (
  `timeOfMove` datetime NOT NULL,
  `gameID` smallint(6) NOT NULL,
  `curPiece` enum('pawn','bishop','knight','rook','queen','king') collate latin1_german1_ci NOT NULL,
  `curColor` enum('white','black') collate latin1_german1_ci NOT NULL,
  `fromRow` smallint(6) NOT NULL,
  `fromCol` smallint(6) NOT NULL,
  `toRow` smallint(6) NOT NULL,
  `toCol` smallint(6) NOT NULL,
  `replaced` enum('pawn','bishop','knight','rook','queen','king') collate latin1_german1_ci default NULL,
  `promotedTo` enum('pawn','bishop','knight','rook','queen','king') collate latin1_german1_ci default NULL,
  `isInCheck` tinyint(1) NOT NULL,
  PRIMARY KEY  (`timeOfMove`,`gameID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;


CREATE TABLE IF NOT EXISTS `chessmessages` (
  `msgID` int(11) NOT NULL auto_increment,
  `gameID` smallint(6) NOT NULL,
  `msgType` enum('undo','draw') collate latin1_german1_ci NOT NULL,
  `msgStatus` enum('request','approved','denied') collate latin1_german1_ci NOT NULL,
  `destination` enum('black','white') collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`msgID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci AUTO_INCREMENT=6 ;

-- this line is for stats used by hall-of-fame
-- ALTER TABLE `accounts` ADD `chessgameswon` MEDIUMINT NOT NULL DEFAULT '0';
