<? /* functions for outputting to html and javascript */

	function drawboard()
	{
		global $board, $playersColor, $numMoves, $str_extpath;

		/* find out if it's the current player's turn */
		if (( (($numMoves == -1) || (($numMoves % 2) == 1)) && ($playersColor == "white"))
				|| ((($numMoves % 2) == 0) && ($playersColor == "black")) )
			$isPlayersTurn = true;
		else
			$isPlayersTurn = false;

		/* determine who's perspective of the board to show */
		$perspective = $playersColor;
		
		/* determine if board is disabled */
		$isDisabled = isBoardDisabled();

		$str_out.="<table border='1'>\n";
		if ($isDisabled)
			$str_out.="<tr bgcolor='#DDDDDD'>";
		else
			$str_out.="<tr bgcolor='#FEFEDD'>";

		/* setup vars to show player's perspective of the board */
		if ($perspective == "white")
		{
			$topRow = 7;
			$bottomRow = 0;
			$rowStep = -1;
			
			$leftCol = 0;
			$rightCol = 7;
			$colStep = 1;
		}
		else
		{
			$topRow = 0;
			$bottomRow = 7;
			$rowStep = 1;
			
			$leftCol = 7;
			$rightCol = 0;
			$colStep = -1;
		}
		
		/* column headers */
		$str_out.="<th>&nbsp;</th>";
		
		/* NOTE: end condition is ($rightCol + $colStep) since we want to output $rightCol */
		for ($i = $leftCol; $i != ($rightCol + $colStep); $i += $colStep)
			$str_out.="<th>`~".chr($i + 97)."`0</th>";
		
		$str_out.="</tr>\n";

		/* for each row... */
		/* NOTE: end condition is ($bottomRow + $rowStep) since we want to output $bottomRow */
		for ($i = $topRow; $i != ($bottomRow + $rowStep); $i += $rowStep)
		{
			$str_out.="<tr>\n";
			if ($isDisabled)
				$str_out.="<th width='20' bgcolor='#DDDDDD'>`~".($i+1)."`0</th>\n";
			else
				$str_out.="<th width='20' bgcolor='#FEFEDD'>`~".($i+1)."`0</th>\n";

			/* for each col... */
			/* NOTE: end condition is ($rightCol + $colStep) since we want to output $rightCol */
			for ($j = $leftCol; $j != ($rightCol + $colStep); $j += $colStep)
			{
				$str_out.="   <td bgcolor='";

				/* if board is disabled, show board in grayscale */
				if ($isDisabled)
				{
					if (($j + ($i % 2)) % 2 == 0)
						$str_out.="#444444'>";
					else
						$str_out.="#BBBBBB'>";
				}
				else
				{
					if (($j + ($i % 2)) % 2 == 0)
						$str_out.="#772222'>";
					else
						$str_out.="#CCBBBB'>";
				}

				/* if disabled or not player's turn, can't click pieces */
				if (!$isDisabled && $isPlayersTurn)
				{
					$str_out.="<a href='JavaScript:squareClicked($i,$j,";
					if ($board[$i][$j] == 0)
						$str_out.="true)'>";
					else
						$str_out.="false)'>";
				}

				$str_out.="<img name='pos$i-$j' src='".$str_extpath."images/";

				/* if position is empty... */
				if ($board[$i][$j] == 0)
				{
					/* draw empty square */
					$tmpGIF="blank";
					$tmpALT="leer";
				}
				else
				{
					/* draw correct piece */
					if ($board[$i][$j] & BLACK)
					{
						$tmpGIF = "black_";
						$tmpALT = "schwarz ";
					}
					else
					{
						$tmpGIF = "white_";
						$tmpALT = "wei ";
					}

					$tmpPiece=getPieceName($board[$i][$j]);
					$tmpGIF .= $tmpPiece;
					$tmpALT .= chess_translate($tmpPiece);
				}

				$str_out.=$tmpGIF.".gif' height='50' width='50' border='0' alt='".$tmpALT."'>";
				
				if (!$isDisabled && $isPlayersTurn)
					$str_out.="</a>";
				
				$str_out.="</td>\n";
			}

			$str_out.="</tr>\n";
		}

		$str_out.="</table>\n\n";
		return($str_out);
	}

	function writeJSboard()
	{
		global $board, $numMoves, $str_extpath;

		/* write out constants */
		$str_out.="var DEBUG = ".DEBUG.";
		
		var CURRENTTHEME = '".$_SESSION['pref_theme']."';
		var EXTPATH = '".$str_extpath."';
		var PAWN = ".PAWN.";
		var KNIGHT = ".KNIGHT.";
		var BISHOP = ".BISHOP.";
		var ROOK = ".ROOK.";
		var QUEEN = ".QUEEN.";
		var KING = ".KING.";
		var BLACK = ".BLACK.";
		var WHITE = ".WHITE.";
		var COLOR_MASK = ".COLOR_MASK.";";
		
		/* write code for array */
		$str_out.="var board = new Array();\n";
		for ($i = 0; $i < 8; $i++)
		{
			$str_out.="board[$i] = new Array();\n";

			for ($j = 0; $j < 8; $j++)
			{
				$str_out.="board[$i][$j] = ".$board[$i][$j].";\n";
			}
		}

		$str_out.="var numMoves = $numMoves;\n";
		$str_out.="var errMsg = '';\n";	/* global var used for error messages */
		
		return($str_out);
	}

	/* provide history data to javascript function */
	/* NOTE: currently, only pawn validation script uses history */
	function writeJSHistory()
	{
		global $history, $numMoves;

		/* write out constants */
		$str_out.="var CURPIECE = 0;
		var CURCOLOR = 1;
		var FROMROW = 2;
		var FROMCOL = 3;
		var TOROW = 4;
		var TOCOL = 5;\n";
		
		/* write code for array */
		$str_out.="var chessHistory = new Array();\n";
		for ($i = 0; $i <= $numMoves; $i++)
		{
			$str_out.="chessHistory[$i] = new Array();
			chessHistory[$i][CURPIECE] = '".$history[$i]['curPiece']."';
			chessHistory[$i][CURCOLOR] = '".$history[$i]['curColor']."';
			chessHistory[$i][FROMROW] = ".$history[$i]['fromRow'].";
			chessHistory[$i][FROMCOL] = ".$history[$i]['fromCol'].";
			chessHistory[$i][TOROW] = ".$history[$i]['toRow'].";
			chessHistory[$i][TOCOL] = ".$history[$i]['toCol'].";\n";
		}
		
		return($str_out);
}
	
	function writeVerbousHistory()
	{
		global $history, $numMoves;

		$str_out.="<table width='300' border='1'>
		<tr><th bgcolor='#FEFEDD' colspan='2'>`~VERLAUF`0</th></tr>\n";

		for ($i = $numMoves; $i >= 0; $i--)
		{
			if ($i % 2 == 1)
			{
				$str_out.="<tr bgcolor='black'>
				<td width='20'>`&".($i + 1)."`0</td><td>`&";
			}
			else
			{
				$str_out.="<tr bgcolor='white'>
				<td width='20'>`~".($i + 1)."`0</td><td>`~";
			}

			$tmpReplaced = "";
			if (!is_null($history[$i]['replaced']))
				$tmpReplaced = $history[$i]['replaced'];
			
			$tmpPromotedTo = "";
			if (!is_null($history[$i]['promotedTo']))
				$tmpPromotedTo = $history[$i]['promotedTo'];

			$tmpCheck = ($history[$i]['isInCheck'] == 1);
			
			$str_out.=moveToVerbousString($history[$i]['curColor'], $history[$i]['curPiece'], $history[$i]['fromRow'], $history[$i]['fromCol'], $history[$i]['toRow'], $history[$i]['toCol'], $tmpReplaced, $tmpPromotedTo, $tmpCheck);
			
			$str_out.="`0</td></tr>\n";
		}
		
		$str_out.="<tr bgcolor='#BBBBBB'><td>0</td><td>Neues Spiel</td></tr>
		</table>\n";
		
		return ($str_out);
	}

	function writeHistoryPGN()
	{
		global $history, $numMoves;

		$str_out.="<table border='1'>
		<tr><th bgcolor='#FEFEDD' colspan='3'>`~VERLAUF`0</th></tr>
		<tr><th bgcolor='#BBBBBB' width='50'>`~Zug`0</th>
		<th bgcolor='white' width='80'><font color='black'>Wei</font></th>
		<th bgcolor='black' width='80'><font color='white'>Schwarz</font></th></tr>\n";

		for ($i = 0; $i <= $numMoves; $i+=2)
		{
			$str_out.="<tr><td align='center' bgcolor='#BBBBBB'>`~".(($i/2) + 1)."`0</td><td bgcolor='white' align='center'><font color='black'>";

			$tmpReplaced = "";
			if (!is_null($history[$i]['replaced']))
				$tmpReplaced = $history[$i]['replaced'];
			
			$tmpPromotedTo = "";
			if (!is_null($history[$i]['promotedTo']))
				$tmpPromotedTo = $history[$i]['promotedTo'];

			$tmpCheck = ($history[$i]['isInCheck'] == 1);
			
			$str_out.=moveToPGNString($history[$i]['curColor'], $history[$i]['curPiece'], $history[$i]['fromRow'], $history[$i]['fromCol'], $history[$i]['toRow'], $history[$i]['toCol'], $tmpReplaced, $tmpPromotedTo, $tmpCheck);

			$str_out.="</font></td><td bgcolor='black' align='center'><font color='white'>";

			if ($i == $numMoves)
				$str_out.="&nbsp;";
			else
			{
				$tmpReplaced = "";
				if (!is_null($history[$i+1]['replaced']))
					$tmpReplaced = $history[$i+1]['replaced'];
			
				$tmpPromotedTo = "";
				if (!is_null($history[$i+1]['promotedTo']))
					$tmpPromotedTo = $history[$i+1]['promotedTo'];

				$tmpCheck = ($history[$i+1]['isInCheck'] == 1);
			
				$str_out.=moveToPGNString($history[$i+1]['curColor'], $history[$i+1]['curPiece'], $history[$i+1]['fromRow'], $history[$i+1]['fromCol'], $history[$i+1]['toRow'], $history[$i+1]['toCol'], $tmpReplaced, $tmpPromotedTo, $tmpCheck);
			}
			
			$str_out.="</font></td></tr>\n";
		}
		
		$str_out.="</table>\n";
		
		return($str_out);
	}

	function writeHistory()
	{
		global $session;
		/* based on player's preferences, display the history */
		if($session['user']['prefs']['chesshistory']=='pgn') //Option: kompakte Ausgabe
		{
			return(writeHistoryPGN());
		}
		else //default: Textausgabe
		{
			return(writeVerbousHistory());
		}
	}

	function writeStatus()
	{
		global $numMoves, $history, $isCheckMate, $statusMessage, $isPlayersTurn;

		$str_out.='
		<table border="1" width="300" align="center">
		<tr bgcolor="#FEFEDD">
			<th>`~
			STATUS - 
			'.($isPlayersTurn?"Dein Zug":"Gegnerischer Zug").'
			`0</th>
		</tr>

		<tr>';
		if (($numMoves == -1) || ($numMoves % 2 == 1))
			$curColor = "white";
		else
			$curColor = "black";

		if (!$isCheckMate && ($history[$numMoves]['isInCheck'] == 1))
			$str_out.="<td align='center' bgcolor='red'>\n<b>".ucfirst(chess_translate($curColor))." ist in Schach!</b><br>\n".$statusMessage."</td>\n";
		else
			$str_out.="<td>".$statusMessage."&nbsp;</td>
			</tr>
		</table>";
		
		return($str_out);
	}

	function writePromotion()
	{
		$str_out.='<p>
		<table width="435" border="1">
		<tr><td>
			Wandle Bauer in:
			<br>
			<input type="radio" name="promotion" value="'.QUEEN.'" checked="checked"> Dame
			<input type="radio" name="promotion" value="'.ROOK.'"> Turm
			<input type="radio" name="promotion" value="'.KNIGHT.'"> Springer
			<input type="radio" name="promotion" value="'.BISHOP.'"> Lufer
			<input type="button" class="bitton" name="btnPromote" value="Tausch" onClick="promotepawn()" />
		</td></tr>
		</table>
		</p>';
		
		return($str_out);
	}

	function writeUndoRequest()
	{
		$str_out.='<p>
		<table width="435" border="1">
		<tr><td>
			Dein Gegner mchte seinen letzten Zug zurcknehmen. Stimmst du zu?
			<br>
			<input type="radio" name="undoResponse" value="yes"> Ja
			<input type="radio" name="undoResponse" value="no" checked="checked"> Nein
			<input type="hidden" name="isUndoResponseDone" value="no">
			<input type="button" class="button" value="Senden" onClick="this.form.isUndoResponseDone.value = \'yes\'; this.form.submit()">
		</td></tr>
		</table>
		</p>';
		
		return($str_out);
	}

	function writeDrawRequest()
	{
		$str_out.='<p>
		<table width="435" border="1">
		<tr><td>
			Dein Gegner bietet Remis an. Nimmst du an?
			<br>
			<input type="radio" name="drawResponse" value="yes"> Ja
			<input type="radio" name="drawResponse" value="no" checked="checked"> Nein
			<input type="hidden" name="isDrawResponseDone" value="no">
			<input type="button" class="button" value="Senden" onClick="this.form.isDrawResponseDone.value = \'yes\'; this.form.submit()">
		</td></tr>
		</table>
		</p>';
		
		return($str_out);
	}
?>
